Loading...
Searching...
No Matches
WenoStencil< GridT, RealT > Class Template Reference

This is a special 19-point stencil that supports optimal fifth-order WENO upwinding, second-order central differencing, Laplacian, and zero-crossing test. More...

`#include <nanovdb/util/Stencils.h>`

Inheritance diagram for WenoStencil< GridT, RealT >:

## Public Types

using | GridType = GridT
using | TreeType = typename GridT::TreeType
using | ValueType = typename GridT::ValueType
using | AccessorType

## Public Member Functions

__hostdev__ | WenoStencil (const GridType &grid)
__hostdev__ | WenoStencil (const GridType &grid, double dx)
__hostdev__ ValueType | normSqGrad (ValueType isoValue=ValueType(0)) const
| Return the norm-square of the WENO upwind gradient (computed via WENO upwinding and Godunov's scheme) at the previously buffered location.
__hostdev__ Vec3< ValueType > | gradient (const Vec3< ValueType > &V) const
__hostdev__ Vec3< ValueType > | gradient () const
__hostdev__ ValueType | laplacian () const
__hostdev__ bool | zeroCrossing () const
template<int i, int j, int k>
__hostdev__ unsigned int | pos () const
| Return linear offset for the specified stencil point relative to its center.
__hostdev__ void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.
__hostdev__ const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos.
__hostdev__ void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil.
__hostdev__ ValueType | mean () const
| Return the mean value of the current stencil.
__hostdev__ ValueType | min () const
| Return the smallest value in the stencil buffer.
__hostdev__ ValueType | max () const
| Return the largest value in the stencil buffer.
__hostdev__ const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil.
__hostdev__ const ValueType & | getCenterValue () const
| Return the value at the center of the stencil.
__hostdev__ bool | intersects (const ValueType &isoValue=ValueType(0)) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue.
__hostdev__ Mask | intersectionMask (ValueType isoValue=ValueType(0)) const
| Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.
__hostdev__ const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed.
__hostdev__ const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil.

## Static Public Member Functions

static __hostdev__ int | size ()
| Return the size of the stencil buffer.

## Static Public Attributes

static constexpr int | SIZE = 19

## Protected Attributes

const GridType * | mGrid
Coord | mCenter

## Friends

template<typename, int, typename>
class | BaseStencil

## Detailed Description

template<typename GridT, typename RealT = typename GridT::ValueType>
class nanovdb::WenoStencil< GridT, RealT >

This is a special 19-point stencil that supports optimal fifth-order WENO upwinding, second-order central differencing, Laplacian, and zero-crossing test.

Note
  For optimal random access performance this class includes its own grid accessor.

## Member Typedef Documentation

## AccessorType

using AccessorType

inherited

## GridType

template<typename GridT, typename RealT = typename GridT::ValueType>

using GridType = GridT

## TreeType

template<typename GridT, typename RealT = typename GridT::ValueType>

using TreeType = typename GridT::TreeType

## ValueType

template<typename GridT, typename RealT = typename GridT::ValueType>

using ValueType = typename GridT::ValueType

## Constructor & Destructor Documentation

## WenoStencil() [1/2]

template<typename GridT, typename RealT = typename GridT::ValueType>

__hostdev__ WenoStencil | ( | const GridType & | grid | ) |

inline

## WenoStencil() [2/2]

template<typename GridT, typename RealT = typename GridT::ValueType>

__hostdev__ WenoStencil | ( | const GridType & | grid,
|  | double | dx )

inline

## Member Function Documentation

## accessor()

__hostdev__ const AccessorType & accessor | ( |  | ) | const

inline inherited

Return a const reference to the ValueAccessor associated with this Stencil.

## getCenterCoord()

__hostdev__ const Coord & getCenterCoord | ( |  | ) | const

inline inherited

Return the coordinates of the center point of the stencil.

## getCenterValue()

__hostdev__ const ValueType & getCenterValue | ( |  | ) | const

inline inherited

Return the value at the center of the stencil.

## getValue()

__hostdev__ const ValueType & getValue | ( | unsigned int | pos = 0 | ) | const

inline inherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## gradient() [1/2]

template<typename GridT, typename RealT = typename GridT::ValueType>

__hostdev__ Vec3< ValueType > gradient | ( |  | ) | const

inline

Return the gradient computed at the previously buffered location by second-order central differencing.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## gradient() [2/2]

template<typename GridT, typename RealT = typename GridT::ValueType>

__hostdev__ Vec3< ValueType > gradient | ( | const Vec3< ValueType > & | V | ) | const

inline

Return the optimal fifth-order upwind gradient corresponding to the direction V.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## grid()

__hostdev__ const GridType & grid | ( |  | ) | const

inline inherited

Return a const reference to the grid from which this stencil was constructed.

## intersectionMask()

__hostdev__ Mask intersectionMask | ( | ValueType | isoValue = ValueType(0) | ) | const

inline inherited

Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use (mask & (1u<<2)) where mask is ther return value from this function. To check if there are any intersections use mask!=0u, and for no intersections use mask==0u. To count the number of intersections use __builtin_popcount(mask).

## intersects()

__hostdev__ bool intersects | ( | const ValueType & | isoValue = ValueType(0) | ) | const

inline inherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## laplacian()

template<typename GridT, typename RealT = typename GridT::ValueType>

__hostdev__ ValueType laplacian | ( |  | ) | const

inline

Return the Laplacian computed at the previously buffered location by second-order central differencing.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## max()

__hostdev__ ValueType max | ( |  | ) | const

inline inherited

Return the largest value in the stencil buffer.

## mean()

__hostdev__ ValueType mean | ( |  | ) | const

inline inherited

Return the mean value of the current stencil.

## min()

__hostdev__ ValueType min | ( |  | ) | const

inline inherited

Return the smallest value in the stencil buffer.

## moveTo()

__hostdev__ void moveTo | ( | const Coord & | ijk | ) |

inline inherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## normSqGrad()

template<typename GridT, typename RealT = typename GridT::ValueType>

__hostdev__ ValueType normSqGrad | ( | ValueType | isoValue = ValueType(0) | ) | const

inline

Return the norm-square of the WENO upwind gradient (computed via WENO upwinding and Godunov's scheme) at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## pos()

template<typename GridT, typename RealT = typename GridT::ValueType>
template<int i, int j, int k>

__hostdev__ unsigned int pos | ( |  | ) | const

inline

Return linear offset for the specified stencil point relative to its center.

## setValue()

__hostdev__ void setValue | ( | const ValueType & | value | ) |

inline inherited

Set the value at the specified location relative to the center of the stencil.

## size()

__hostdev__ int size | ( |  | ) |

inline static inherited

Return the size of the stencil buffer.

## zeroCrossing()

template<typename GridT, typename RealT = typename GridT::ValueType>

__hostdev__ bool zeroCrossing | ( |  | ) | const

inline

Return `true` if the sign of the value at the center point of the stencil differs from the sign of any of its six nearest neighbors

## Friends And Related Symbol Documentation

## BaseStencil

template<typename GridT, typename RealT = typename GridT::ValueType>
template<typename, int, typename>

friend class BaseStencil

friend

## Member Data Documentation

## mCenter

Coord mCenter

protected inherited

## mGrid

const GridType* mGrid

protected inherited

## SIZE

template<typename GridT, typename RealT = typename GridT::ValueType>

int SIZE = 19

static constexpr